<?php
addSmartyPlugin('output','add_piwik_tag');
addPollenPlugin('addPluginsTabs','tabPiwikConfig');
addPollenPlugin('adminmainmenu','admin_piwik_btn_stats');



function tabPiwikConfig($tabExtraPlugins){
	
	$oPlugin = new PPluginDir(dirname(__FILE__));
	$oPiwikConfigFile = &$oPlugin->oConfig;
	
	$tabExtraPlugins[]=array(
		'FRAG_NAME'=>'plugins_piwik',
		'TAB_NAME'=>_('Piwik'),
		'TAB_CONTENT'=>$oPiwikConfigFile->DisplayEditor()
	);	
	
	return true;
}

function admin_piwik_btn_stats(){
	$oCurrentFile = new PFile(__FILE__);
	
	$oPlugin = new PPluginDir(dirname(__FILE__));
	$oConfigFile = &$oPlugin->oConfig;
	if( $oConfigFile->getDirectParam('PIWIK_ACTIVATE') !== "true" ) return '';
	$strPiwikUrl = $oConfigFile->getDirectParam("PIWIK_URL");
	if(!$strPiwikUrl) return '';
	
	$strLogin = $oConfigFile->getDirectParam('PIWIK_LOGIN');
	$strClearPasswd = $oConfigFile->getDirectParam('PIWIK_CLEAR_PASSWD');
	if($strLogin && $strClearPasswd){
		$strPiwikUrl = $strPiwikUrl.'?module=Login&action=logme&login='.$strLogin.'&password='.md5($strClearPasswd);	
	}
	
	return '
		<td>
		<a href="'.$strPiwikUrl.'" target="_blank"  class="panel-link infobulles" id="actualites">
		<img src="'.SITE_URL.'plugins/piwik/img/stats.jpg" />
			<span>
				<h3> Gestion des stats </h3>
				<p>Dans cette espace vous pouvez voir vos statistiques d\'accès à vore site web.</p>
			</span>
		</a>
		</td>
	';
	
}

function add_piwik_tag($source, &$smarty)
{
	$oCurrentFile = new PFile(__FILE__);
	
	$oPlugin = new PPluginDir(dirname(__FILE__));
	$oConfigFile = &$oPlugin->oConfig;
		
	if( $oConfigFile->getDirectParam('PIWIK_ACTIVATE') !== "true" ) return $source;
	
	$id = intval($oConfigFile->getDirectParam("PIWIK_ID"));
	$strPiwikUrl = $oConfigFile->getDirectParam("PIWIK_URL");
	
	if($id!='' && $id > 0 && $strPiwikUrl !='' && strstr($source,'</body>')!==FALSE){
		$strPageName = preg_replace('/^'.preg_quote(SITE_URL,'/~').'/','',$smarty->oPageCurrent->getUrl());
		$strPiwik = 		'
<!-- Add By Piwik Plugin  -->
		<a href="http://piwik.org" title="Web analytics" onclick="window.open(this.href);return(false);">
		<script type="text/javascript">
		var pkBaseURL = "'.$strPiwikUrl.'";
		document.write(unescape("%3Cscript src=\'" + pkBaseURL + "piwik.js\' type=\'text/javascript\'%3E%3C/script%3E"));
		</script><script type="text/javascript">
		piwik_action_name = "'.$strPageName.'";
		piwik_idsite = '.$id.';
		piwik_url = pkBaseURL + "piwik.php";
		piwik_log(piwik_action_name, piwik_idsite, piwik_url);
		</script>
		<object><noscript><p>Web analytics <img src="'.$strPiwikUrl.'piwik.php?idsite='.$id.'" style="border:0" alt=""/></p></noscript></object></a>
<!-- /Add By Piwik Plugin --> 
		';
		$source = preg_replace('/\<\/body\>/i',$strPiwik.'</body>',$source);		
	}
	return $source;

}
?>